<?php
/**
 * "TRAVELbook - JOOMLA! on Tour" - http://www.demo-page.de
 *
 * @version         $Id: admin views tours view.html.php 001 2010-01-22 12:00:00$
 * @copyright       Copyright 2009-2010, Peter H&ouml;cherl
 * @license         GNU General Public License (GNU GPL) GPLv2, 
 *                  - see http://www.demo-page.de/en/license-conditions.html *
 *    This program is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * @link            http://www.demo-page.de
 * @package         TRAVELbook Component
 * @revision        $Revision: 001 $
 * @lastmodified    $Date: 2010-01-22 12:00:00 $
*/

/*** No direct access ***/
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.html.pane');
jimport( 'joomla.application.component.view');

/**
 * Travelbook View
 *
 * @package    Travelbook
 * @subpackage administrator
 */ 
class TravelbooksViewTours extends JView
{
	/** 
	 * display method of Travelbook view
	 * @return void
	 **/
	function display($tpl = null)
	{

		$db =& JFactory::getDBO();
		
		$document = &JFactory::getDocument();
		$document->addStyleSheet( 'components/com_travelbook/assets/css/travelbook.css' );
		$document->addStyleSheet( 'components/com_travelbook/assets/css/calendar.css' );
		$document->addScript( 'components/com_travelbook/assets/js/calendar.js' );


		$tour	=& $this->get('tour');
		$isNew        = ($tour->id < 1);
		
		$text = $isNew ? JText::_( 'New' ) : JText::_( 'Edit' );
		JToolBarHelper::title(   JText::_( 'Hello' ).': <small><small>[ ' . $text.' ]</small></small>' );


// Title and Ikons
		$history = Jrequest::getVar('history','tours.cancel');
		$task = JRequest::getCmd('task', 'travelbooks.show');
		switch ($task) {
			case 'tours.show':
					JToolBarHelper::title(   JText::_( 'TB Tours' ).' <small><small>[ ' .JText::_( 'TB List' ).' ]</small></small>' , 'tour');
					JToolBarHelper::publish( 'tours.publish', 'Publish' );
					JToolBarHelper::unpublish( 'tours.unpublish', 'Unpublish' );
					JToolBarHelper::deleteListX( JText::_( 'TB Are You sure?' ),'tours.delete', 'Delete' );
					JToolBarHelper::editListX( 'tours.edit', 'Edit' );
					JToolBarHelper::addNewX( 'tours.add', 'New' );
				break;
			case 'tours.detail':
					JToolBarHelper::addNew( 'tours.addhotels', 'TB Add Hotels' );
					JToolBarHelper::addNew( 'tours.addservices', 'TB Add Services' );
					JToolBarHelper::addNew( 'tours.addseason', 'TB Add Season' );
					JToolBarHelper::divider();
					JToolBarHelper::title(   JText::_( 'TB Tours' ).' <small><small>[ ' .JText::_( 'TB Details' ).' ]</small></small>' , 'tour');
					JToolBarHelper::save( 'tours.save', 'Save' );
					JToolBarHelper::apply( 'tours.apply', 'Apply' );
					JToolBarHelper::cancel( $history, 'Cancel' );
					JToolBarHelper::back( 'Back' );
				break;
			case 'tours.add':
					JToolBarHelper::title(   JText::_( 'TB Tours' ).' <small><small>[ ' .JText::_( 'TB Add new Tour' ).' ]</small></small>' , 'tour');
					JToolBarHelper::save( 'tours.save', 'Save' );
					JToolBarHelper::apply( 'tours.apply', 'Apply' );
					JToolBarHelper::cancel( 'tours.cancel', 'Cancel' );
					JToolBarHelper::back( 'Back' );
				break;
			case 'tours.addseason':
					JToolBarHelper::title(   JText::_( 'TB Tours' ).' <small><small>[ ' .JText::sprintf( 'Add a new Season to',$tour->title ).' ]</small></small>' , 'tour');
					JToolBarHelper::save( 'tours.saveseason', 'Save' );
					JToolBarHelper::cancel( 'tours.canceladdseason', 'Cancel' );
					JToolBarHelper::back( 'Back' );
				break;
		}

// Filters and co
		global $mainframe, $option_tour, $orderby, $where, $pageNav;
	
		$filter_order		= $mainframe->getUserStateFromRequest( $option_tour.'filter_order', 		'filter_order', 	'tours.ordering',	'cmd' );
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option_tour.'filter_order_Dir',		'filter_order_Dir',	'',					'word' );
		$filter_state 		= $mainframe->getUserStateFromRequest( $option_tour.'filter_state', 		'filter_state', 	'',					'word' );
		$filter_catid 		= $mainframe->getUserStateFromRequest( $option_tour.'filter_catid', 		'filter_catid',		0,					'int' );
		$search 			= $mainframe->getUserStateFromRequest( $option_tour.'search', 				'search', 			'',					'string' );
		$search 			= JString::strtolower( $search );
	
		$limit				= $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
		$limitstart			= $mainframe->getUserStateFromRequest($option_tour.'.limitstart', 'limitstart', 0, 'int');
	
		$where = array();
	
		if ( $search ) {
			$where[] = 'tours.title LIKE '.$db->Quote( '%'.$db->getEscaped( $search, true ).'%', false );
		}

		if ( $filter_catid ) {
			$where[] = 'tours.catid = '.(int) $filter_catid;
		}

		if ( $filter_state ) {
			if ( $filter_state == 'P' ) {
				$where[] = 'tours.published = 1';
			} else if ($filter_state == 'U' ) {
				$where[] = 'tours.published = 0';
			}
		}
	
		$where 		= ( count( $where ) ? ' WHERE ' . implode( ' AND ', $where ) : '' );
		if ($filter_order == 'tours.ordering'){
			$orderby 	= ' ORDER BY category, tours.ordering';
		} else {
			$orderby 	= ' ORDER BY '. $filter_order .' '. $filter_order_Dir .', category, tours.ordering';
		}
	
// get the total number of records
		$total	=& $this->get('total');
		$this->assignRef('total', $total);	

		jimport('joomla.html.pagination');

		$pageNav = new JPagination( $total, $limitstart, $limit );

// get the subset (based on limits) of required records
		$tours	=& $this->get('subset');
		$this->assignRef('tours', $tours);	

// get the subset (based on limits) of required records
		$tour	=& $this->get('tour');
		$this->assignRef('tour', $tour);	

// build list of categories
		$javascript = 'onchange="document.adminForm.submit();"';
		$lists['catid'] = JHTML::_('list.category',  'filter_catid', 'com_tour_details', intval( $filter_catid ), $javascript );
// state filter
		$lists['state']	= JHTML::_('grid.state',  $filter_state );
// table ordering
		$lists['order_Dir']	= $filter_order_Dir;
		$lists['order']		= $filter_order;
// search filter
		$lists['search']= $search;
		$this->assignRef('lists',		$lists);	

// Details
// build list of categories
	$details['catid'] = JHTML::_('list.category',  'catid', 'com_tour_details', intval( $tour->catid ) );
// build the html radio buttons for published
	$details['published'] = JHTML::_('select.booleanlist',  'published', '', $tour->published );
// build the html radio buttons for select_hotel
	$details['select_hotel'] = JHTML::_('select.booleanlist',  'select_hotel', '', $tour->select_hotel );
// build the html select list for ordering
	$query = 'SELECT ordering AS value, title AS text'
	. ' FROM #__tb_journey'
	. ' WHERE published >= 0'
	. ' AND catid = '.(int) $tour->catid
	. ' ORDER BY ordering'
	;
	$details['ordering'] 			= JHTML::_('list.specificordering',  $tour, $tour->id, $query );

	$this->assignRef('details',		$details);	

	parent::display($tpl);

	}

/**
* render Seasons
*/
	 function renderSeasons () {
	 	$output = '';

		$output = '<div style="padding: 5px;">';
		$output .= "<table class='adminlist'>\n";

		$output .= "	<thead>\n";
		$output .= "		<tr class='sortable'>\n";
		$output .= "			<th width='10'> ".JText::_( 'Num' )."</th>\n";
		$output .= "			<th  width='33%' nowrap='nowrap' style='text-align: left;'> ".JText::_( 'TB Departure' )."</th>\n";
		$output .= "			<th  width='33%' nowrap='nowrap' style='text-align: right;'> ".JText::_( 'TB Arrival' )."</th>\n";
		$output .= "			<th  width='2%' nowrap='nowrap'> ".JText::_( 'TB Available' )."</th>\n";
		$output .= "			<th  width='15%' nowrap='nowrap' style='text-align: right;'> ".JText::_( 'TB Rate' )."</th>\n";
		$output .= "			<th  width='15%' nowrap='nowrap' style='text-align: right;'> ".JText::_( 'TB Single' )."</th>\n";
		$output .= "		</tr>\n";
		$output .= "	</thead>\n";

		$seasons	=& $this->get('seasons');
		$i = 0;
		foreach ($seasons as $season) {
			$i++;
			$link = JRoute::_( 'index.php?option=com_travelbook&task=seasons.detail&tid[]='. $season->id );

			$output .= "	<tr class='row".$season->id."'>\n";
			$output .= "		<td>\n";
			$output .= $i;
			$output .=  "		</td>\n";
			$output .= "		<td style='text-align: left;'>\n";
			$output .= "<a href='".$link."'>".JHTML::_('date', $season->departure, JText::_('DATE_FORMAT_LC1'))."</a> ";
			$output .=  "		</td>\n";
			$output .= "		<td style='text-align: right;'>\n";
			$output .= JHTML::_('date', $season->arrival, JText::_('DATE_FORMAT_LC1'))." ";
			$output .=  "		</td>\n";
			$output .= "		<td style='text-align: center;'>\n";
			$output .= $season->available;
			$output .=  "		</td>\n";
			$output .= "		<td style='text-align: right;'>\n";
			$output .= number_format($season->rate, 0, ',', '.')." &euro;";
			$output .=  "		</td>\n";
			$output .= "		<td style='text-align: right;'>\n";
			$output .= number_format($season->single_supplement, 0, ',', '.')." &euro;";
			$output .=  "		</td>\n";
			$output .=  "	</tr>\n";
		}

		$output .= "</table>\n";
		$output .= '</div>';
		
		return $output;
	 }

/**
* render Services
*/
	 function renderServices () {
	 	$output = '';

		$output = '<div style="padding: 5px;">';
		$output .= "<table class='adminlist'>\n";

		$output .= "	<thead>\n";
		$output .= "		<tr class='sortable'>\n";
		$output .= "			<th width='10'> ".JText::_( 'Num' )."</th>\n";
		$output .= "			<th  width='33%' nowrap='nowrap' style='text-align: left;'> ".JText::_( 'TB Service' )."</th>\n";
		$output .= "			<th  width='33%' nowrap='nowrap' style='text-align: right;'> ".JText::_( 'TB Category' )."</th>\n";
		$output .= "			<th  width='15%' nowrap='nowrap' style='text-align: right;'> ".JText::_( 'TB Type' )."</th>\n";
		$output .= "			<th  width='15%' nowrap='nowrap' style='text-align: right;'> ".JText::_( 'TB Rate' )."</th>\n";
		$output .= "		</tr>\n";
		$output .= "	</thead>\n";

		$services	=& $this->get('services');
		$i = 0;
		foreach ($services as $service) {
			$i++;
			$link = JRoute::_( 'index.php?option=com_travelbook&task=services.detail&cid[]='. $service->id );

			$output .= "	<tr class='row".$service->id."'>\n";
			$output .= "		<td>\n";
			$output .= $i;
			$output .=  "		</td>\n";
			$output .= "		<td style='text-align: left;'>\n";
			$output .= "<a href='".$link."'>".$service->name."</a> ";
			$output .=  "		</td>\n";
			$output .= "		<td style='text-align: right;'>\n";
			$output .= $service->title;
			$output .=  "		</td>\n";
			$output .= "		<td style='text-align: right;'>\n";
			$output .= $service->category;
			$output .=  "		</td>\n";
			$output .= "		<td style='text-align: right;'>\n";
			$output .= number_format($service->rate, 0, ',', '.')." &euro;";
			$output .=  "		</td>\n";
			$output .=  "	</tr>\n";
		}

		$output .= "</table>\n";
		$output .= '</div>';
		
		return $output;
	 }
	 
/**
* render Accomodation
*/
	 function renderAccomodation () {
	 	$output = '';

		$output = '<div style="padding: 5px;">';
		$output .= "<table class='adminlist'>\n";

		$output .= "	<thead>\n";
		$output .= "		<tr class='sortable'>\n";
		$output .= "			<th width='10'> ".JText::_( 'Num' )."</th>\n";
		$output .= "			<th  nowrap='nowrap' style='text-align: left;'> ".JText::_( 'TB Hotel' )."</th>\n";
		$output .= "			<th  width='20%' nowrap='nowrap' style='text-align: right;'> ".JText::_( 'TB Category' )."</th>\n";
		$output .= "			<th  width='24%' nowrap='nowrap' style='text-align: right;'> ".JText::_( 'TB City' )."</th>\n";
		$output .= "			<th  width='12' nowrap='nowrap' style='text-align: right;'> ".JText::_( 'TB Nights' )."</th>\n";
		$output .= "			<th  width='18%' nowrap='nowrap' style='text-align: right;'> ".JText::_( 'TB Rate' )."</th>\n";
		$output .= "		</tr>\n";
		$output .= "	</thead>\n";

		$hotels	=& $this->get('hotels');
		$i = 0;
		foreach ($hotels as $hotel) {
			$i++;
			$link = JRoute::_( 'index.php?option=com_travelbook&task=hotels.detail&tid[]='. $hotel->id );

			$output .= "	<tr class='row".$hotel->id."'>\n";
			$output .= "		<td>\n";
			$output .= $i;
			$output .=  "		</td>\n";
			$output .= "		<td style='text-align: left;'>\n";
			$output .= "<a href='".$link."'>".$hotel->name."</a> ";
			$output .=  "		</td>\n";
			$output .= "		<td style='text-align: right;'>\n";
			$output .= $hotel->title;
			$output .=  "		</td>\n";
			$output .= "		<td style='text-align: right;'>\n";
			$output .= $hotel->city;
			$output .=  "		</td>\n";
			$output .= "		<td style='text-align: right;'>\n";
			$output .= $hotel->accomodation;
			$output .=  "		</td>\n";
			$output .= "		<td style='text-align: right;'>\n";
			$output .= number_format($hotel->rate, 2, ',', '.')." &euro;";
			$output .=  "		</td>\n";
			$output .=  "	</tr>\n";
		}

		$output .= "</table>\n";
		$output .= '</div>';
		
		return $output;
	 }
	 	
}